# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from iobase.xmldata import (
    XmlNode,
)
from ionas.backupsync.info import TargetInfo


MAX_UPLOAD_SIZE = 5120  # MB


class HomeBox2TargetInfo(TargetInfo):

    def __init__(self, target_xmlnode):
        super(HomeBox2TargetInfo, self).__init__(
            target_xmlnode.get_value('type'),
            None,
        )

        # get parameters
        self._target_xmlnode = target_xmlnode
        self._boxid = target_xmlnode.get_value('boxid', default=None)
        self._loginid, self._portal = self._boxid.split('@')[:2]
        self._password = target_xmlnode.get_value('password', default=None)
        self._folder = target_xmlnode.get_value('folder', default=None)
        self._max_upload_size = int(target_xmlnode.get_value('upload_max_size', default=MAX_UPLOAD_SIZE))

        # TODO: validate
        if self._max_upload_size > MAX_UPLOAD_SIZE:
            raise Exception('max upload size too large ({0})'.format(
                self._max_upload_size,
            ))

    @property
    def boxid(self):
        return self._boxid

    @property
    def loginid(self):
        return self._loginid

    @property
    def portalid(self):
        return self._portal

    @property
    def password(self):
        return self._password

    @property
    def folder(self):
        return self._folder

    @property
    def max_upload_size(self):
        return self._max_upload_size
