# vim:ts=4 sw=4 sts=4 ai si et sta
from __future__ import print_function
from __future__ import unicode_literals
from __future__ import absolute_import
from __future__ import division

from ionas.request import XmlConfNode as Node


def node_to_dict(_node):
    _dict = {}
    _dict['boxid'] = _node.get_value('boxid')
    _dict['password'] = _node.get_value('password')
    _dict['folder'] = _node.get_value('folder')
    _dict['upload_max_size'] = int(_node.get_value('upload_max_size', '1024'))
    return _dict


def dict_to_node(_dict, tagname):
    _node = Node(tagname)
    _node.append_child('boxid', text=_dict['boxid'])
    _node.append_child('password', text=_dict['password'])
    _node.append_child('folder', text=_dict['folder'])
    _node.append_child('upload_max_size', text='{0}'.format(_dict.get('upload_max_size', 1024)))
    return _node
