#!/usr/bin/env python
# -*- coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from __future__ import print_function
from __future__ import unicode_literals
from __future__ import absolute_import
from __future__ import division

import os
try:
    import json
except ImportError:
    import simplejson as json

from django.utils.translation import ugettext as _
from django.http import HttpResponse

from project.view import RootView

from project.fal.chbox import CHBox as HomeBox2
from .form import GetDirnamesForm


class GetDirnamesView(RootView):

    REQUIRED_LOGIN = False

    views = []

    def view(self, request):
        form = GetDirnamesForm(data=request.POST)
        if form.is_valid():
            boxid = form.cleaned_data['boxid']
            loginid, portal = boxid.split('@')[:2]
            password = form.cleaned_data['password']
            folders = HomeBox2().list(
                portal=portal,
                loginid=loginid,
                passwd=password,
            )
            response = HttpResponse(
                json.dumps([folder['path'] for folder in folders]),
                mimetype='application/json;charset=UTF-8;',
            )
            return {
                self.KEY_RESPONSE: response,
            }
